      SUBROUTINE  iterb(fatal,nc,manual)
c
c...Full Array Iteration
c
      INCLUDE
     *         'proc.inc'
      PARAMETER
     *         npfudge = 100000,
     *         nitmax = 25
      INTEGER
     *         ok, err, nold, fatal, nc, manual, niter
c
 9001 FORMAT (' Fatal Error In Pairfit')
 9002 FORMAT (' NPAIR=', i8, '  Sx=', f10.2, '   Sx=', f10.2,
     *        '  NCoef=', i2, '  Niter=', i2)
 9003 FORMAT (' Enter Find Radius (Micron): ' $)
 9004 FORMAT (f10.0)
c
  100 rmicron = 20.0
      nold = npair
      niter = 0
  110 CALL xform
      CALL pairfind
      CALL pairfit(x1, xcoef,sxcoef,sigmax, err)
      IF (err.ne.0) THEN
        WRITE (*,9001)
        fatal = 9
        RETURN
      ENDIF
      CALL pairfit(y1, ycoef,sycoef,sigmay, err)
      IF (err.ne.0) THEN
        WRITE (*,9001)
        fatal = 10
        RETURN
      ENDIF
      sigmax = 0.01D00*sigmax
      sigmay = 0.01D00*sigmay
      WRITE (*,9002) npair,sigmax,sigmay,ncoef,niter
c
c...Iterate Until NPAIR Is The Same
c
      IF (manual.eq.0) THEN
        IF (ABS(npair-nold).gt.(npair/NPFUDGE)) THEN
          nold = npair
          niter = niter+1
          IF (niter.gt.NITMAX) THEN
            fatal = 17
            RETURN
          ENDIF
          IF ((niter.ge.2).and.(npair.le.(MIN(n1,n2)/100))) THEN
            fatal = 18
            RETURN
          ENDIF
          IF ((niter.ge.4).and.(npair.le.(MIN(n1,n2)/10))) THEN
            fatal = 19
            RETURN
          ENDIF
          GO TO 110
        ENDIF
      ELSE
        CALL isitok(ok)
        IF (ok.ge.0) THEN
          IF (ok.eq.0) THEN
  120       WRITE (*,9003)
            READ  (*,9004,err=120,end=200) rmicron
          ENDIF
          GO TO 110
        ENDIF
      ENDIF
c
c...Final (Hopefully Quick) Iteration For More Plate Constants)
c
      IF (nc.ne.ncoef) THEN
        ncoef = nc
  130   CALL pairfind
        CALL pairfit(x1, xcoef,sxcoef,sigmax, err)
        IF (err.ne.0) THEN
          WRITE (*,9001)
          fatal = 7
          RETURN
        ENDIF
        CALL pairfit(y1, ycoef,sycoef,sigmay, err)
        IF (err.ne.0) THEN
          WRITE (*,9001)
          fatal = 8
          RETURN
        ENDIF
        sigmax = 0.01D00*sigmax
        sigmay = 0.01D00*sigmay
        WRITE (*,9002) npair,sigmax,sigmay,ncoef
        IF (ABS(npair-nold).gt.(npair/NPFUDGE)) THEN
          nold = npair
          CALL xform
          GO TO 130
        ENDIF
      ENDIF
      RETURN
c
c...Read EOF
c
  200 CALL EXIT
      END
