      SUBROUTINE  extract2
c
c...Get Geometry Limits And Produce List
c
      INCLUDE
     *            'magover.inc'
      INTEGER
     *            xmin, xmax, ymin, ymax, i, nlb, n, j
      INTEGER
     *            rx1, rx2, ry1, ry2, xl, yl, rl, x, y
      CHARACTER*64
     *            lb
      REAL
     *            dx, dy, rsqr, test
c
 9001 FORMAT (' List (2)  X(', i10, ',', i10, ')   Y(', i10, ',',
     *        i10, ')')
 9002 FORMAT (' Enter X,Y,R: ' $)
 9003 FORMAT (' Enter X,Y,R [', i6, 2(',',i6), ']: ' $)
 9004 FORMAT (3i10)
 9007 FORMAT (q, a)
 9008 FORMAT (' No Stars Found In Box')
c
c...Get Limits
c
  100 xmin = x2(1)
      xmax = x2(1)
      ymin = y2(1)
      ymax = y2(1)
      DO i=2,n2
        xmin = MIN(xmin,x2(i))
        xmax = MAX(xmax,x2(i))
        ymin = MIN(ymin,y2(i))
        ymax = MAX(ymax,y2(i))
      ENDDO
      rx1 = xmin/100
      rx2 = xmax/100
      ry1 = ymin/100
      ry2 = ymax/100
      WRITE (*,9001) rx1,rx2,ry1,ry2
c
c...Get User's Version
c
  110 IF (x2min.eq.TAG) THEN
        WRITE (*,9002)
        READ  (*,9004,err=110,end=200) xl,yl,rl
        xl = 100*xl
        yl = 100*yl
        rl = 100*rl
      ELSE
        xl = (x2max+x2min)/200
        yl = (y2max+y2min)/200
        rl = MAX((x2max-x2min),(y2max-y2min))/200
        WRITE (*,9003) xl,yl,rl
        READ  (*,9007,err=110,end=200) nlb,lb
        IF (nlb.gt.0) THEN
          READ (lb(1:nlb),9004,err=110) xl,yl,rl
        ENDIF
        xl = 100*xl
        yl = 100*yl
        rl = 100*rl
      ENDIF
      x2min = xl-rl
      x2max = xl+rl
      y2min = yl-rl
      y2max = yl+rl
c
c...Find Stars In Box And Sort On TOTAL Magnitude
c
      n = 0
      DO i=1,n2
        IF (x2(i).ge.x2min) THEN
          IF (x2(i).le.x2max) THEN
            IF ((y2(i).ge.y2min).and.(y2(i).le.y2max)) THEN
              n = n+1
              idx(n) = i
              tmp(n) = d2(i)
            ENDIF
          ELSE
            GO TO 130
          ENDIF
        ENDIF
      ENDDO
  130 IF (n.le.0) THEN
        WRITE (*,9008)
        GO TO 100
      ENDIF
      CALL iuqsrt(n,tmp,idx)
c
c...Save A Few
c
      test = (MAX(x2max-x2min,y2max-y2min)*0.005)**2
      n2p = 0
      DO i=1,n
        x = x2(idx(i))
        y = y2(idx(i))
        IF (n2p.le.0) THEN
          n2p = 1
          x2p(n2p) = x
          y2p(n2p) = y
          m2p(n2p) = tmp(i)
          q2p(n2p) = q2(idx(i))
          i2p(n2p) = idx(i)
        ELSE
          DO j=1,n2p
            dx = x2p(j)-x
            dy = y2p(j)-y
            IF ((dx*dx+dy*dy).le.test) GO TO 140
          ENDDO
          n2p = n2p+1
          x2p(n2p) = x
          y2p(n2p) = y
          m2p(n2p) = tmp(i)
          q2p(n2p) = q2(idx(i))
          i2p(n2p) = idx(i)
  140     CONTINUE
        ENDIF
        IF (n2p.ge.NEXTMAX) GO TO 150
      ENDDO
  150 CONTINUE
c
c...Sort On X For Pair Finding
c
      DO i=1,n2p
        idx(i) = i
      ENDDO
      CALL iuqsrt(n2p,x2p,idx)
      CALL ireord(n2p,idx,y2p,tmp)
      CALL ireord(n2p,idx,m2p,tmp)
      CALL ireord(n2p,idx,q2p,tmp)
      CALL ireord(n2p,idx,i2p,tmp)
      RETURN
c
c...Errors
c
  200 CALL EXIT
      END
