      SUBROUTINE  each(id,fatal,nc,manual)
c
c...Process This ID
c
      INCLUDE
     *            'tbproc.inc'
      INTEGER
     *            id, fatal, old, nc, manual, i, snipit, nlb
      DOUBLE PRECISION
     *            zref, z, zl, zm, zh, sl, sm, sh, dz, s, x
      CHARACTER*64
     *            lb
c
 9001 FORMAT (i5, 9f8.3)
 9002 FORMAT ('FATAL=', i10, ' For ', a)
c
c...Input And First Guess
c
  100 fatal = 0
      IF (color.eq.'SB') THEN
        CALL tbdefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'SR') THEN
        CALL trdefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'SO') THEN
        CALL todefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'SE') THEN
        CALL tedefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'SJ') THEN
        CALL tjdefault(id,fatal,old)
        snipit = 1
      ELSEIF (color.eq.'SF') THEN
        CALL tfdefault(id,fatal,old)
        snipit = 1
      ELSEIF (color.eq.'SN') THEN
        CALL tndefault(id,fatal,old)
        snipit = 1
      ELSEIF (color.eq.'UJ') THEN
        CALL tudefault(id,fatal,old)
        snipit = 1
      ELSEIF (color.eq.'NA') THEN
        CALL npmadefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'NB') THEN
        CALL npmbdefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'NY') THEN
        CALL npmydefault(id,fatal,old)
        snipit = 0
      ELSEIF (color.eq.'AO') THEN
        CALL aaodefault(id,fatal,old)
        snipit = 0
      ELSE
        STOP 'Illegal Color'
      ENDIF
      IF (fatal.ne.0) RETURN
      CALL getvignette
      CALL taffload(id,fatal)
      IF (fatal.ne.0) RETURN
      CALL gimme1(fatal)
      IF (fatal.ne.0) RETURN
      CALL gimme2(fatal)
      IF (fatal.ne.0) RETURN
      CALL getccd
c
c...Loop Using Different Values Of ZETACUR
c
      zref = zetacur
      zl = 0.0D00
      CALL zetaproc(id,zl,nc,old,manual,snipit,sl,fatal)
      IF (fatal.ne.0) RETURN
      dz = 0.2D00
      zm = zl + dz
      CALL zetaproc(id,zm,nc,old,manual,snipit,sm,fatal)
      IF (fatal.ne.0) RETURN
      IF (sm.lt.sl) THEN
        zh = zm + dz
        CALL zetaproc(id,zh,nc,old,manual,snipit,sh,fatal)
        IF (fatal.ne.0) RETURN
        IF (sh.lt.sm) THEN
  111     zl = zm
          sl = sm
          zm = zh
          sm = sh
          zh = zm+dz
          CALL zetaproc(id,zh,nc,old,manual,snipit,sh,fatal)
          IF (fatal.ne.0) RETURN
          IF (sh.lt.sm) GO TO 111
        ENDIF
      ELSE
  112   zh = zm
        sh = sm
        zm = zl
        sm = sl
        zl = zm-dz
        CALL zetaproc(id,zl,nc,old,manual,snipit,sl,fatal)
        IF (fatal.ne.0) RETURN
        IF (sl.lt.sm) GO TO 112
      ENDIF
c
c...Bracketed or error.  Look at minimum if possible.
c
      IF (fatal.eq.0) THEN
        x = ((sh-sm)/(sh+sl-2.0D00*sm)) + 0.5D00
        z = zh - dz*x
        CALL zetaproc(id,z,nc,old,manual,snipit,s,fatal)
        IF (fatal.ne.0) RETURN
        IF (dotaff.eq.0) THEN
          lb = 'zeta.'//color(1:2)
          nlb = 7
        ELSE
          lb = 'zetataff.'//color(1:2)
          nlb = 11
        ENDIF
        OPEN (
     *        access='append',
     *        carriagecontrol='list',
     *        dispose='keep',
     *        form='formatted',
     *        name=lb(1:nlb),
     *        status='unknown',
     *        unit=1
     *       )
        WRITE (1,9001) id,zref,zl,sl,zm,sm,zh,sh,z,s
        CLOSE (1)
      ELSE
        OPEN (
     *        access='append',
     *        carriagecontrol='list',
     *        dispose='keep',
     *        form='formatted',
     *        name='realquiet.log',
     *        status='unknown',
     *        unit=1
     *       )
        WRITE (1,9002) fatal,fn2(nfn2-6:nfn2)
        CLOSE (1)
        RETURN
      ENDIF
c
c...Compute Magnitudes
c
      CALL magproc(id)
c
c...Process Strings And Compute RA/Dec
c
      CALL fakeres
      CALL dumpit(1)
      RETURN
      END
