      SUBROUTINE  aopairs(id,np,p1,p2,
     *                     n1,x1,y1,
     *                     n2,x2,y2,m2,
     *                     nc,xc,yc,
     *                     ps,err)
c
c...Transform, Check, And Keep The Pairs
c
      INCLUDE
     *           'ugap012.inc'
      PARAMETER
     *            scale = 1.0D08
      INTEGER
     *            np, p1(*), p2(*), n1, x1(*), y1(*), n2, x2(*),
     *            y2(*), m2(*), nc, id, xx1, yy1, xx2, yy2, i, i1, i2,
     *            j, err, ps(*)
      DOUBLE PRECISION
     *            xc(*), yc(*), sx, sxx, sy, syy, x, y, dv(16),
     *            xhat, yhat
c
 9001 FORMAT (' A+', a, ' F=', i3, '  NP=', i7, '  X=', f6.2, '+/-',
     *        f5.2, '  Y=', f6.2, '+/-', f5.2, ' microns')
 9002 FORMAT (' Illegal GOPAIRS Index', 4i10)
c
c...Transform All Of (2)
c
  100 DO i=1,n2
        x = x2(i)/SCALE
        y = y2(i)/SCALE
        xhat = 0.0D00
        yhat = 0.0D00
        dv( 1) = 1.0D00
        dv( 2) = x
        dv( 3) = y
        dv( 4) = x*x
        dv( 5) = x*y
        dv( 6) = y*y
        dv( 7) = x*x*x
        dv( 8) = x*x*y
        dv( 9) = x*y*y
        dv(10) = y*y*y
        DO j=1,nc
          xhat = xhat + dv(j)*xc(j)
          yhat = yhat + dv(j)*yc(j)
        ENDDO
        x2(i) = SCALE*xhat + 0.5D00
        y2(i) = SCALE*yhat + 0.5D00
      ENDDO
c
c...Compute Statistics From Pairs.
c
      sx = 0.0D00
      sy = 0.0D00
      sxx = 0.0D00
      syy = 0.0D00
      DO i=1,np
        i1 = p1(i)
        IF ((i1.lt.1).or.(i1.gt.n1)) THEN
          WRITE (*,9002) i,i1,i2,n1
          err = -32
          RETURN
        ENDIF
        i2 = p2(i)
        IF ((i2.lt.1).or.(i2.gt.n2)) THEN
          WRITE (*,9002) i,i1,i2,n2
          err = -33
          RETURN
        ENDIF
        x = x1(i1)-x2(i2)
        y = y1(i1)-y2(i2)
        sx = sx + x
        sxx = sxx + x*x
        sy = sy + y
        syy = syy + y*y
      ENDDO
c
c...Do Statistics To Reassure The User
c
      sx = sx/np
      sxx = SQRT(sxx/np - sx*sx)
      sy = sy/np
      syy = SQRT(syy/np - sy*sy)
      ps(1) = sx
      ps(2) = sxx
      ps(3) = sy
      ps(4) = syy
      sx = 0.01D00*sx
      sy = 0.01D00*sy
      sxx = 0.00717D00*sxx
      syy = 0.00717D00*syy
      WRITE ( *,9001) color(2:2),id,np,sx,sxx,sy,syy
      WRITE (10,9001) color(2:2),id,np,sx,sxx,sy,syy
      err = 0
      RETURN
      END
