      SUBROUTINE  select(nfind,ifind,jfind,rfind,dfind,mfind,zone)
c
c...Figure Out Which One To Keep
c
      INCLUDE
     *            'ugap5.inc'
      PARAMETER
     *            billion = 1000*1000*1000,
     *            million = 1000*1000,
     *            thousand = 1000,
     *            sf = (10.0D00/360000.0D00)
      INTEGER
     *            nfind, ifind(*), jfind(*), mfind(*), i, m, msign,
     *            mbad, mblue, mred, who, which, prio, value, id,
     *            mfield, rfind(*), dfind(*), dx, dy, dr, zone,
     *            as(100), bs(100), cs(100), ds(100), kill, north,
     *            south, xmm, ymm, mm(100)
      DOUBLE PRECISION
     *            cosdec
c
c...PreFiltering Needed For North/South Overlap Zone
c
  100 kill = 0
      IF ((zone.ge.650).and.(zone.le.750)) THEN
        south = 0
        north = 0
        DO i=1,nfind
          mfield = MOD(ABS(mfind(i)),BILLION)/MILLION
          IF (mfield.gt.0) THEN
            IF (mfield.le.606) THEN
              south = south+1
            ELSE
              north = north+1
            ENDIF
          ENDIF
        ENDDO
        IF ((south.gt.0).and.(north.gt.0)) THEN
          kill = 1
        ENDIF
      ENDIF
c
c...Now Select The Highest Priority Object
c
      prio = 500
      value = 9999
      id = -1
      DO i=1,nfind
c
c...Crack Each Magnitude
c
        m = mfind(i)
        IF (m.lt.0) THEN
          msign = -1
          m = -m
        ELSE
          msign = 1
        ENDIF
        mbad = m/BILLION
        m = m - mbad*BILLION
        mfield = m/MILLION
        m = m - mfield*MILLION
        mblue = m/THOUSAND
        mred = m - mblue*THOUSAND
c
c...If FIELD==0 This Is ACT or TYC Star Not Found By PMM
c
        IF (mfield.eq.0) THEN
          which = mred
          IF (mbad.eq.0) THEN
            who = 200
          ELSE
            who = 100
          ENDIF
c
c...This Is A PMM Star.  If negative, it is correlated with ACT star.
c
c	NEW!  Add Radial Distance As A Penalty
c
        ELSE
          which = mblue
          IF (msign.le.0) THEN
            who = 300
          ELSE
            who = 400
          ENDIF
          IF ((dfind(i).le.DBREAK).and.(mfield.le.FBREAK)) THEN
            dx = (rfind(i)-ssra(mfield))
            dy = (dfind(i)-ssdec(mfield))
            cosdec = cssdec(mfield)
          ELSE
            dx = (rfind(i)-p1ra(mfield))
            dy = (dfind(i)-p1dec(mfield))
            cosdec = cp1dec(mfield)
          ENDIF
          IF (dx.lt.-HALF) THEN
            dx = dx+CIRCLE
          ELSEIF (dx.gt.HALF) THEN
            dx = dx-CIRCLE
          ENDIF
          dr = SQRT((cosdec*dx*SF)**2 + (dy*SF)**2)
          as(i) = dx
          bs(i) = dy
          cs(i) = dr
          ds(i) = who
          who = who+dr
          xmm = obs_xmid - dx*cosdec*obs_tomm
          ymm = obs_ymid + dy*obs_tomm
          mm(i) = 10000*MAX(0,MIN(9999,xmm)) + MAX(0,MIN(9999,ymm))
        ENDIF
c
c...Keep Brightest Of Highest Priority
c
c	Note Extra Logic For North/South Overlap
c
        IF ((kill.eq.0).or.(mfield.le.606)) THEN
          IF (who.lt.prio) THEN
            prio = who
            value = which
            id = i
          ELSEIF (who.eq.prio) THEN
            IF (which.lt.value) THEN
              value = which
              id = i
            ENDIF
          ENDIF
        ENDIF
      ENDDO
c
c...This Test Better Fail.  TAG The Others
c
      IF (id.le.0) THEN
      do i=1,nfind
      write (*,9991) i,ifind(i),jfind(i),mfind(i),as(i),bs(i),cs(i),
     * ds(i)
      enddo
      pause 'Cannot SELECT'
 9991 format (i3,7i11)
      ELSE
        CALL dosame(nfind,mfind,id,mm)
        DO i=1,nfind
          IF (i.ne.id) THEN
            IF (jfind(i).eq.1) THEN
              CALL dotag1(ifind(i))
            ELSE
              CALL dotag2(ifind(i))
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END
