      SUBROUTINE  magproc(color,survey)
c
c...Fit Common Slope And Individual Offsets
c
      INCLUDE
     *            'ugapb.inc'
      PARAMETER
     *            const = 150,
     *            ratio = 300.0D00,
     *            fixed = 100,
     *            faint = 110
      INTEGER
     *            i, j, err, color, survey, test
      CHARACTER*5
     *            fn
c
 9001 FORMAT ('c', i1, 's', i1, '.')
c
c...Set Up Defaults And Select Stars
c
  100 DO i=1,NCMAX
        nin(i) = 0
        nout(i) = 0
      ENDDO
      WRITE (fn,9001) color,survey
c
c...First Iteration Is All Unsaturated Stars
c
      DO i=1,nfit
        j = jfit(i)
        IF ((sfit(i).eq.0).and.(mfit(i).lt.FAINT)) THEN
          idx(i) = 1
          nin(j) = nin(j)+1
          nin(1) = nin(1)+1
        ELSE
          idx(i) = 0
          nout(j) = nout(j)+1
          nout(1) = nout(1)+1
        ENDIF
      ENDDO
      CALL magfit(survey,err)
      CALL resid
      CALL saveit(fn//'1',survey)
      IF (err.le.0) RETURN
c
c...Trim Residuals At A Fixed Size
c
      j = RATIO*sigmam
      test = MIN(j,CONST)
      DO i=1,nmcoef
        nin(i) = 0
        nout(i) = 0
      ENDDO
      DO i=1,nfit
        j = jfit(i)
        IF ((ABS(tmp(i)).le.test).and.(mfit(i).lt.FAINT)) THEN
          idx(i) = 1
          nin(j) = nin(j)+1
          nin(1) = nin(1)+1
        ELSE
          idx(i) = 0
          nout(j) = nout(j)+1
          nout(1) = nout(1)+1
        ENDIF
      ENDDO
      CALL magfit(survey,err)
      CALL resid
      CALL saveit(fn//'2',survey)
      IF (err.le.0) RETURN
c
c...Save As A Function Of Sigmas
c
      test = RATIO*sigmam
      DO i=1,nmcoef
        nin(i) = 0
        nout(i) = 0
      ENDDO
      DO i=1,nfit
        j = jfit(i)
        IF ((ABS(tmp(i)).le.test).and.(mfit(i).lt.FAINT)) THEN
          idx(i) = 1
          nin(j) = nin(j)+1
          nin(1) = nin(1)+1
        ELSE
          idx(i) = 0
          nout(j) = nout(j)+1
          nout(1) = nout(1)+1
        ENDIF
      ENDDO
      CALL magfit(survey,err)
      CALL resid
      CALL saveit(fn//'3',survey)
c
c...All Done
c
      RETURN
      END
