      SUBROUTINE  dofit2r(err)
c
c...BIG Least Square Fit To RED Data
c
      INCLUDE
     *            'ugapc3.inc'
      INTEGER
     *            i, j, k, ising, nfree, err, jj(3)
      DOUBLE PRECISION
     *            chisq, y, yc, resid
c
c...Initialization
c
  100 DO i=1,nc
        rcoef(i) = 0.0D00
        zlhs(i) = 0.D00
        DO j=1,nc
          zrhs(i,j) = 0.0D00
        ENDDO
      ENDDO
      chisq = 0.0D00
      nin = 0
c
c...Accumulation
c
      DO i=1,mm
        IF (ir(i).ne.0) THEN
          IF (pq(i).le.2000) THEN
            jj(1) = 1
            jj(2) = 2
          ELSE
            jj(1) = 3
            jj(2) = 4
          ENDIF
          dv(1) = xr(i)
          dv(2) = dv(1)*xr(i)
          jj(3) = pn(i)+4
          dv(3) = 1.0D00
          DO j=1,3
            zlhs(jj(j)) = zlhs(jj(j)) + dv(j)*yr(i)
            DO k=1,3
              zrhs(jj(j),jj(k)) = zrhs(jj(j),jj(k)) + dv(j)*dv(k)
            ENDDO
          ENDDO
          nin = nin+1
        ENDIF
      ENDDO
c
c...Inversion
c
      nfree = nin - (nc+1)
      IF (nfree.le.0) THEN
        err = -1
        RETURN
      ENDIF
      CALL inv2(ising)
      IF (ising.ne.0) THEN
        err = -2
        RETURN
      ENDIF
c
c...Coefficients
c
      DO i=1,nc
        DO j=1,nc
          rcoef(i) = rcoef(i) + zrhs(i,j)*zlhs(j)
        ENDDO
      ENDDO
c
c...Residuals And ChiSquared
c
      DO i=1,mm
        IF (pq(i).le.2000) THEN
          jj(1) = 1
          jj(2) = 2
        ELSE
          jj(1) = 3
          jj(2) = 4
        ENDIF
        dv(1) = xr(i)
        dv(2) = dv(1)*xr(i)
        jj(3) = pn(i)+4
        dv(3) = 1.0D00
        yc = 0.0D00
        DO j=1,3
          yc = yc + dv(j)*rcoef(jj(j))
        ENDDO
        resid = yr(i)-yc
        re(i) = resid
        IF (ir(i).ne.0) THEN
          chisq = chisq + resid*resid
        ENDIF
      ENDDO
c
c...Errors
c
      sigmar = SQRT(chisq/nfree)
      DO i=1,nc
        srcoef(i) = sigmar*SQRT(zrhs(i,i))
      ENDDO
      err = 0
      RETURN
      END
