      SUBROUTINE  dstfind
c
c...Look In Sorted Lists For Pairs In SubArea Lists
c
      INCLUDE
     *            'ugapc0.inc'
      PARAMETER
     *            nqmax = 100
      INTEGER
     *            get, low, high, xl, xh, nfind, r,
     *            ifind(NQMAX), jfind(NQMAX), test, yl, yh, yt
      DOUBLE PRECISION
     *            rsqr, dx, dy, dr, z, rfind(NQMAX)
c
c...Initialization
c
  100 get = 0
      npair = 0
      low = 1
      high = 1
      r = P12SCALE*etol + 0.5
      rsqr = r*r
c
c...Outer Loop Over (1) Index
c
  110 get = get+1
      IF (get.gt.np1) THEN
        RETURN
      ENDIF
      xl = xp1(get) - r
      xh = xp1(get) + r
      yl = yp1(get) - r
      yh = yp1(get) + r
c
c...Inner Loop Brackets (2)
c
  120 CONTINUE
      IF (x2hat(low).lt.xl) THEN
        IF (low.lt.np2) THEN
          low = low+1
          GO TO 120
        ENDIF
      ENDIF
      IF (x2hat(low).gt.xh) GO TO 110
      IF (high.lt.low) THEN
        high = low
      ENDIF
  130 CONTINUE
      IF (high.lt.np2) THEN
        IF (x2hat(high+1).le.xh) THEN
          high = high+1
          GO TO 130
        ENDIF
      ENDIF
c
c...Test All Entries In This Range
c
      nfind = 0
      DO test=low,high
        yt = y2hat(test)
        IF ((yt.ge.yl).and.(yt.le.yh)) THEN
          dy = yt-yp1(get)
          dx = x2hat(test)-xp1(get)
          dr = dx*dx + dy*dy
          IF (dr.le.rsqr) THEN
            IF (nfind.lt.NQMAX) THEN
              nfind = nfind+1
              ifind(nfind) = get
              jfind(nfind) = idx(test)
              rfind(nfind) = dr
            ENDIF
          ENDIF
        ENDIF
      ENDDO
c
c...Save Pairs
c
      IF (nfind.gt.0) THEN
        npair = npair+1
        pair1(npair) = ifind(1)
        pair2(npair) = jfind(1)
        z = rfind(1)
        DO test=2,nfind
          IF (rfind(test).lt.z) THEN
            pair1(npair) = ifind(test)
            pair2(npair) = jfind(test)
            z = rfind(test)
          ENDIF
        ENDDO
      ENDIF
c
c...Loop Until Completion.  RETURN Is On GET
c
      GO TO 110
      END
